package com.ibm.r2a.rules.rdj.examples.j2sebestpractices.cloneable;


public class OverrideClone_Example implements Cloneable {
	
	public OverrideClone_Example() {
		super();
		elements = new int[ 1 ];
	}

	public void setElements( int value ) {
		for ( int i = 0; i < elements.length; i++ ) {
			elements[ i ] = value;
		}
	}

	public void print() {
		for ( int i = 0; i < elements.length; i++ ) {
			System.out.println( elements[ i ] );
		}
	}

	private int[] elements;

	public static void main(String[] args){
		OverrideClone_Example original = new OverrideClone_Example();
		original.setElements( 1 );
	
		OverrideClone_Example clone = null;
		try {
			clone = (OverrideClone_Example)original.clone();
			System.out.println( "Clone before modification of original" ); //$NON-NLS-1$
			clone.print();
			original.setElements( 2 );
			System.out.println( "Clone after modification of original" ); //$NON-NLS-1$
			clone.print();
			}catch( CloneNotSupportedException e ) {
				e.printStackTrace();
			}
	}

}
